OptionsWindow = class( Turbine.UI.Lotro.Window );

local holder = function(parent, height)
    local container = Turbine.UI.Control();
    container:SetSize(parent:GetWidth()-40, height);
    parent:AddItem(container);
    return container;
end

function OptionsWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetVisible( false );
	self:SetText( "Vital Bars" );
	self:SetSize( 400, 580 );

	self.PlayerOptions = Turbine.UI.ListBox();
	self.PlayerOptions:SetOrientation( Turbine.UI.Orientation.Horizontal );
	self.PlayerOptions:SetParent( self );
	self.PlayerOptions:SetSize( 375, 470 );
	self.PlayerOptions:SetPosition( 20, 50 );
	self.PlayerOptions:SetMaxItemsPerLine(1);

	local scrollbar = Turbine.UI.Lotro.ScrollBar();
    scrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    scrollbar:SetParent( self.PlayerOptions );
    scrollbar:SetSize(10, 470);
    scrollbar:SetPosition(365, 0);

	self.PlayerOptions:SetVerticalScrollBar( scrollbar );

	self.PlayerOptions.HideCheckBox = Faflaf.FormElements.CheckBox();
	self.PlayerOptions.HideCheckBox:SetParent( self.PlayerOptions );
	self.PlayerOptions.HideCheckBox:SetText( "Show default character vitals?" );
	self.PlayerOptions.HideCheckBox:SetSize( self.PlayerOptions:GetWidth()-40, 40 );
	self.PlayerOptions:AddItem( self.PlayerOptions.HideCheckBox );

	local line = holder(self.PlayerOptions, 40);
    self.PlayerOptions.VisibleTypeLabel = Faflaf.FormElements.Label();
    self.PlayerOptions.VisibleTypeLabel:SetParent(line);
    self.PlayerOptions.VisibleTypeLabel:SetSize(line:GetWidth()-195, 20);
	self.PlayerOptions.VisibleTypeLabel:SetPosition(10, 0);
    self.PlayerOptions.VisibleTypeLabel:SetText("Display options");

	self.PlayerOptions.VisibleTypeCombo = Faflaf.FormElements.ComboBox();
    self.PlayerOptions.VisibleTypeCombo:SetParent(line);
    self.PlayerOptions.VisibleTypeCombo:SetSize(line:GetWidth()-140, 20);
    self.PlayerOptions.VisibleTypeCombo:SetPosition(138, 0);
    self.PlayerOptions.VisibleTypeCombo:AddItem("Side by side", settings.DisplayType.SideBySide);
    self.PlayerOptions.VisibleTypeCombo:AddItem("Show Moral only", settings.DisplayType.MoraleOnly);
    self.PlayerOptions.VisibleTypeCombo:AddItem("Show Power only", settings.DisplayType.PowerOnly);
	self.PlayerOptions.VisibleTypeCombo:AddItem("Stack Morale and Power", settings.DisplayType.Stacked);
	
	-- setup width sliders
	self.PlayerOptions.MoraleSlider = Faflaf.FormElements.Slider();
	self.PlayerOptions.MoraleSlider:SetParent( self.PlayerOptions );
	self.PlayerOptions.MoraleSlider:SetText( "Morale Width" );
	self.PlayerOptions.MoraleSlider:SetSize( self.PlayerOptions:GetWidth()-30, 40 );
	self.PlayerOptions.MoraleSlider:SetStep( 1 );
	self.PlayerOptions.MoraleSlider:SetMin( 100 );
	self.PlayerOptions.MoraleSlider:SetMax( Turbine.UI.Display.GetWidth() );
	self.PlayerOptions:AddItem( self.PlayerOptions.MoraleSlider );
	
	self.PlayerOptions.PowerSlider = Faflaf.FormElements.Slider();
	self.PlayerOptions.PowerSlider:SetParent( self.PlayerOptions );
	self.PlayerOptions.PowerSlider:SetText( "Power Width" );
	self.PlayerOptions.PowerSlider:SetSize( self.PlayerOptions:GetWidth()-30, 40 );
	self.PlayerOptions.PowerSlider:SetStep( 1 );
	self.PlayerOptions.PowerSlider:SetMin( 100 );
	self.PlayerOptions.PowerSlider:SetMax(  Turbine.UI.Display.GetWidth() );
	self.PlayerOptions:AddItem( self.PlayerOptions.PowerSlider );

	self.PlayerOptions.MoraleTextCheckBox = Faflaf.FormElements.CheckBox();
	self.PlayerOptions.MoraleTextCheckBox:SetParent( self.PlayerOptions );
	self.PlayerOptions.MoraleTextCheckBox:SetText( "Display Morale text?" );
	self.PlayerOptions.MoraleTextCheckBox:SetSize( self.PlayerOptions:GetWidth()-40, 40 );
	self.PlayerOptions:AddItem( self.PlayerOptions.MoraleTextCheckBox );

	self.PlayerOptions.MoralePercentCheckBox = Faflaf.FormElements.CheckBox();
	self.PlayerOptions.MoralePercentCheckBox:SetParent( self.PlayerOptions );
	self.PlayerOptions.MoralePercentCheckBox:SetText( "Display Morale as percentage?" );
	self.PlayerOptions.MoralePercentCheckBox:SetSize( self.PlayerOptions:GetWidth()-40, 40 );
	self.PlayerOptions:AddItem( self.PlayerOptions.MoralePercentCheckBox );

	self.PlayerOptions.PowerTextCheckBox = Faflaf.FormElements.CheckBox();
	self.PlayerOptions.PowerTextCheckBox:SetParent( self.PlayerOptions );
	self.PlayerOptions.PowerTextCheckBox:SetText( "Display Power text?" );
	self.PlayerOptions.PowerTextCheckBox:SetSize( self.PlayerOptions:GetWidth()-40, 40 );
	self.PlayerOptions:AddItem( self.PlayerOptions.PowerTextCheckBox );

	self.PlayerOptions.PowerPercentCheckBox = Faflaf.FormElements.CheckBox();
	self.PlayerOptions.PowerPercentCheckBox:SetParent( self.PlayerOptions );
	self.PlayerOptions.PowerPercentCheckBox:SetText( "Display Power as percentage?" );
	self.PlayerOptions.PowerPercentCheckBox:SetSize( self.PlayerOptions:GetWidth()-40, 40 );
	self.PlayerOptions:AddItem( self.PlayerOptions.PowerPercentCheckBox );

	self.PlayerOptions.LevelCheckBox = Faflaf.FormElements.CheckBox();
	self.PlayerOptions.LevelCheckBox:SetParent( self.PlayerOptions );
	self.PlayerOptions.LevelCheckBox:SetText( "Display level on Morale bar?" );
	self.PlayerOptions.LevelCheckBox:SetSize( self.PlayerOptions:GetWidth()-40, 40 );
	self.PlayerOptions:AddItem( self.PlayerOptions.LevelCheckBox );
	
	self.PlayerOptions.NameCheckBox = Faflaf.FormElements.CheckBox();
	self.PlayerOptions.NameCheckBox:SetParent( self.PlayerOptions );
	self.PlayerOptions.NameCheckBox:SetText( "Display Name on Morale bar?" );
	self.PlayerOptions.NameCheckBox:SetSize( self.PlayerOptions:GetWidth()-40, 40 );
	self.PlayerOptions:AddItem( self.PlayerOptions.NameCheckBox );
	
	self.PlayerOptions.InCombatOpacitySlider = Faflaf.FormElements.Slider();
	self.PlayerOptions.InCombatOpacitySlider:SetParent( self.PlayerOptions );
	self.PlayerOptions.InCombatOpacitySlider:SetText( "In combat Opacity" );
	self.PlayerOptions.InCombatOpacitySlider:SetSize( self.PlayerOptions:GetWidth()-30, 40 );
	self.PlayerOptions.InCombatOpacitySlider:SetStep( 1 );
	self.PlayerOptions.InCombatOpacitySlider:SetMin( 0 );
	self.PlayerOptions.InCombatOpacitySlider:SetMax( 10 );
	self.PlayerOptions:AddItem( self.PlayerOptions.InCombatOpacitySlider );

	self.PlayerOptions.OutCombatOpacitySlider = Faflaf.FormElements.Slider();
	self.PlayerOptions.OutCombatOpacitySlider:SetParent( self.PlayerOptions );
	self.PlayerOptions.OutCombatOpacitySlider:SetText( "Out of combat Opacity" );
	self.PlayerOptions.OutCombatOpacitySlider:SetSize( self.PlayerOptions:GetWidth()-30, 40 );
	self.PlayerOptions.OutCombatOpacitySlider:SetStep( 1 );
	self.PlayerOptions.OutCombatOpacitySlider:SetMin( 0 );
	self.PlayerOptions.OutCombatOpacitySlider:SetMax( 10 );
	self.PlayerOptions:AddItem( self.PlayerOptions.OutCombatOpacitySlider );

	-- setup buttons
	self.CancelButton = Turbine.UI.Lotro.Button();
	self.CancelButton:SetParent( self );
	self.CancelButton:SetText( "Cancel" );
	self.CancelButton:SetSize( 70, 20 );
	self.CancelButton:SetPosition( self:GetWidth()-90, self:GetHeight()-40 );
	self.CancelButton.Click = function( sender, args )
		self:Close();
	end

	self.ApplyButton = Turbine.UI.Lotro.Button();
	self.ApplyButton:SetParent( self );
	self.ApplyButton:SetText( "Apply" );
	self.ApplyButton:SetSize( 70, 20 );
	self.ApplyButton:SetPosition( self.CancelButton:GetLeft()-73, self:GetHeight()-40);
	self.ApplyButton.Click = function( sender, args )
		self:ApplyOptions();
	end

	self.OkButton = Turbine.UI.Lotro.Button();
	self.OkButton:SetParent( self );
	self.OkButton:SetText( "Ok" );
	self.OkButton:SetSize( 70, 20 );
	self.OkButton:SetPosition( self.ApplyButton:GetLeft()-73, self:GetHeight()-40 );
	self.OkButton.Click = function( sender, args )
		self:ApplyOptions();
		self:Close();
	end

	self.DefaultsButton = Turbine.UI.Lotro.Button();
	self.DefaultsButton:SetParent( self );
	self.DefaultsButton:SetText( "Defaults" );
	self.DefaultsButton:SetSize( 70, 20 );
	self.DefaultsButton:SetPosition( self.OkButton:GetLeft()-73, self:GetHeight()-40 );
	self.DefaultsButton.Click = function( sender, args )
		local defaultSettings = Settings( true );
		self:SetValues( defaultSettings );
	end
end

function OptionsWindow:VisibleChanged(sender, args)
	if( self:IsVisible() ) then
		self:SetValues( settings )
	end
end

function OptionsWindow:SetValues(values)
	self.PlayerOptions.HideCheckBox:SetChecked( values.ShowDefault );
	self.PlayerOptions.VisibleTypeCombo:SetSelection( values.PlayerDisplayType );
	self.PlayerOptions.MoraleSlider:SetValue( values.MoraleWidth );
	self.PlayerOptions.PowerSlider:SetValue( values.PowerWidth );
	self.PlayerOptions.MoraleTextCheckBox:SetChecked( values.IsMoraleTextVisible );
	self.PlayerOptions.MoralePercentCheckBox:SetChecked( values.UseMoralePercentage );
	self.PlayerOptions.PowerTextCheckBox:SetChecked( values.IsPowerTextVisible );
	self.PlayerOptions.PowerPercentCheckBox:SetChecked( values.UsePowerPercentage );
	self.PlayerOptions.LevelCheckBox:SetChecked( values.IsLevelVisible );
	self.PlayerOptions.NameCheckBox:SetChecked( values.IsNameVisible );
	self.PlayerOptions.InCombatOpacitySlider:SetValue( values.InCombatOpacity );
	self.PlayerOptions.OutCombatOpacitySlider:SetValue( values.OutCombatOpacity );
end

function OptionsWindow:ApplyOptions()
	settings.MoraleWidth = self.PlayerOptions.MoraleSlider:GetValue();
	settings.PowerWidth = self.PlayerOptions.PowerSlider:GetValue();
	settings.UseMoralePercentage = self.PlayerOptions.MoralePercentCheckBox:IsChecked();
	settings.UsePowerPercentage = self.PlayerOptions.PowerPercentCheckBox:IsChecked();
	settings.IsMoraleTextVisible = self.PlayerOptions.MoraleTextCheckBox:IsChecked();
	settings.IsPowerTextVisible = self.PlayerOptions.PowerTextCheckBox:IsChecked();
	settings.IsNameVisible = self.PlayerOptions.NameCheckBox:IsChecked();
	settings.IsLevelVisible = self.PlayerOptions.LevelCheckBox:IsChecked();
	settings.ShowDefault = self.PlayerOptions.HideCheckBox:IsChecked();
	settings.InCombatOpacity = self.PlayerOptions.InCombatOpacitySlider:GetValue();
	settings.OutCombatOpacity = self.PlayerOptions.OutCombatOpacitySlider:GetValue();
	settings.PlayerDisplayType = self.PlayerOptions.VisibleTypeCombo:GetSelection();
	settings:Save();

	vitalsWindow:PerformLayout()

	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, settings.ShowDefault );
end