Settings = class();

function Settings:Constructor()
	self:Constructor( false );
end

function Settings:Constructor( loadDefaults )
	self.DisplayType = {};
	self.DisplayType.SideBySide = 1;
	self.DisplayType.MoraleOnly = 2;
	self.DisplayType.PowerOnly = 3;
	self.DisplayType.Stacked = 4;
	
	if( loadDefaults ) then
		self:SetDefaults();
	else
		self:Load();
	end
end

function Settings:Load()
	local saved = Turbine.PluginData.Load( Turbine.DataScope.Character, "vitalbars" );
	if (type(saved) ~= "table") then
        -- set some reasonable defaults
        self:SetDefaults();
        self:Save()
    else
        for n,v in pairs(saved) do
            self[n] = v;
        end
		self:MakeCurrent();
    end
end

function Settings:SetDefaults()
	self.WindowLeft = 10;
	self.WindowTop = 10;
	self.MoraleWidth = 320;
	self.PowerWidth = 320;
	self.UseMoralePercentage = false;
	self.UsePowerPercentage = false;
	self.IsMoraleTextVisible = true;
	self.IsPowerTextVisible = true;
	self.IsNameVisible = true;
	self.IsLevelVisible = true;
	self.PlayerDisplayType = self.DisplayType.SideBySide;
	self.ShowDefault = false;
	self.InCombatOpacity = 10;
	self.OutCombatOpacity = 10;
end

function Settings:Save()
	Turbine.PluginData.Save( Turbine.DataScope.Character, "vitalbars", self );
end

function Settings:MakeCurrent()
	local tempSettings = Faflaf.VitalBars.Settings( true );
	for n,v in pairs(tempSettings) do
		if( self[n] == nil ) then self[n] = v; end
	end
	for n,v in pairs(self) do
		if( tempSettings[n] == nil ) then self[n] = nil; end
	end
	self:Save();
end